(Re-)Add support for the Sametime protocol.

RESOLVED FIXED in 1.1

Status

Chat Core
General
--
enhancement
RESOLVED FIXED
4 years ago
4 years ago

People

(Reporter: Instantbot, Assigned: clokep)

Tracking

Firefox Tracking Flags

(Not tracked)

Details

Attachments

(2 attachments, 7 obsolete attachments)

(Reporter)

Description

4 years ago
*** Original post on bio 102 by Denis <danykey AT gmail.com> at 2008-08-15 15:05:00 UTC ***

As I understood the new library is not contain libraries for Sametime protocol.
Status: UNCONFIRMED → NEW
Ever confirmed: true
*** Original post on bio 102 at 2011-03-09 20:33:39 UTC ***

Mass-change: Reassigning to nobody all the bugs in the NEW or UNCONFIRMED status where I'm the assignee because I used to be the default assignee of the component.
(Assignee)

Comment 2

4 years ago
*** Original post on bio 102 at 2011-07-08 20:00:33 UTC ***

Since the release of 1.0 we've received a few emails about supporting Sametime, so maybe we'll bring it back. (Just updating a few fields here.)
Severity: major → enhancement
Hardware: x86 → All
(Assignee)

Updated

4 years ago
Summary: Sametime protocol support is lost. → (Re-)Add support for the Sametime protocol.
(Assignee)

Comment 3

4 years ago
Created attachment 8352510 [details] [diff] [review]
Sametime from Pidgin 2.9.0 / Meanwhile 1.0.2

*** Original post on bio 102 as attmnt 768 at 2011-08-02 23:45:00 UTC ***

This patch adds Sametime support (and compiles fine on Windows, I have not tested on Linux/Mac). There's a few changes I made to the original code, they're marked by the string "XXX MSVC Hack".

It seems to load the purple OK, but I don't have access to a Sametime account to test with.  This also doesn't handle the locale, which I'm not sure how to convert.
(Assignee)

Comment 4

4 years ago
*** Original post on bio 102 at 2011-08-15 13:30:52 UTC ***

From a conversation with flo on IRC [1], things to do:
1. Figure out l10n stuff:
To get at least en-US: cd tools/l10n/; ./make-pot-file.sh; python convert-purple-po-files-to-properties-files.py
2. Need to make the update script stop removing the "meanwhile" folder
3. Verify it builds on Mac, Linux
4. Provide a diff of changes from meanwhile 1.0.2 and libpurple 2.9.0
5. Find someone with an account to test :)

I'll be able to do 1, 2 and 4 tonight.

[1] http://log.bezut.info/instantbird/110815/#m107
(Assignee)

Comment 5

4 years ago
Created attachment 8352518 [details] [diff] [review]
Diff of meanwhile 1.0.2

*** Original post on bio 102 as attmnt 776 at 2011-08-16 22:02:00 UTC ***

(In reply to comment #4)
> From a conversation with flo on IRC [1], things to do:
> 1. Figure out l10n stuff:
> To get at least en-US: cd tools/l10n/; ./make-pot-file.sh; python
> convert-purple-po-files-to-properties-files.py
I'm still working on this, I'm missing a binary apparently.

> 2. Need to make the update script stop removing the "meanwhile" folder
Done this, will attach a new patch with the localization file.

> 4. Provide a diff of changes from meanwhile 1.0.2 and libpurple 2.9.0
Attached!
og.bezut.info/instantbird/110815/#m107
(Assignee)

Updated

4 years ago
Assignee: florian → clokep
Status: NEW → ASSIGNED
Created attachment 8352519 [details] [diff] [review]
sametime.properties + a few script changes

*** Original post on bio 102 as attmnt 777 at 2011-08-17 13:40:00 UTC was without comment, so any subsequent comment numbers will be shifted ***
(Assignee)

Comment 7

4 years ago
*** Original post on bio 102 at 2011-08-17 13:51:52 UTC ***

(In reply to comment #5)
> Created an attachment (id=776) [details]
> Diff of meanwhile 1.0.2
> 
> (In reply to comment #4)
> > From a conversation with flo on IRC [1], things to do:
> > 1. Figure out l10n stuff:
> > To get at least en-US: cd tools/l10n/; ./make-pot-file.sh; python
> > convert-purple-po-files-to-properties-files.py
> I'm still working on this, I'm missing a binary apparently.
> 
> > 2. Need to make the update script stop removing the "meanwhile" folder
> Done this, will attach a new patch with the localization file.
> 
> > 4. Provide a diff of changes from meanwhile 1.0.2 and libpurple 2.9.0
> Attached!
Apparently this diff was a bit funky, flo gave me a better way:
use |diff -u| and I think (but I'm not completely sure) the good command to use is |diff -u -U 8 -p|, -U 8 specifying "8 lines of context instead of the default 3, -p adding the function names in the diff

Also my original patch has whitespace changes which need to be removed (so if meanwhile gets updated, we can easily include the update). It also did not include at changes to the libpurple sametime files.

Also, to statically link the purple we should change: http://lxr.instantbird.org/instantbird/source/config/autoconf.mk.in#51

And I'll need to include flo's patch (attachment 8352519 [details] [diff] [review] (bio-attmnt 777)).
(Assignee)

Comment 8

4 years ago
*** Original post on bio 102 at 2011-08-17 14:32:54 UTC ***

More notes from flo:
Add the makefile to http://lxr.instantbird.org/instantbird/source/purple/makefiles.sh#49 (which helps configure generate makefiles faster (all the makefiles listed in that file are generated at once during configure. Others are generated while recursing through the folders)

To fix the static compiling:
in the prpl Makefile, the "PROTOCOL" variable name needs to match the name of the containing folder (like here http://lxr.instantbird.org/instantbird/source/purple/libpurple/protocols/netsoul/Makefile.in#41) So you need to change you |PROTOCOL = meanwhile| line to |PROTOCOL = sametime| (and the value of the PROTOCOL variable is also used as the name of the properties file for localization)

Also the EXTRA_DIST in the makefile is probably unnecessary -- I'm not sure at what point I added it or why.

Compiles OK on Mac according to flo, with the following warnings: http://pastebin.instantbird.com/896 (probably need to fix the multiline comment -- and change all comments to C89 style /* */).
(Assignee)

Comment 9

4 years ago
*** Original post on bio 102 at 2011-08-17 14:34:13 UTC ***

One last comment: keep the list of protocols in purple/libpurple/Makefile.in alphabetized. (netsoul can stay where it is, since it's not part of libpurple, or moved.)
*** Original post on bio 102 at 2011-08-17 15:58:49 UTC ***

Apparently we also need to add this to purple/libpurple/purple-prefs.js:
pref("plugins.prpl.meanwhile.blist_action", 4);

I just saw a warning for this one printed by my debug build. I've grepped quickly the code and I don't think other prefs need default values.
(Assignee)

Comment 11

4 years ago
Created attachment 8352520 [details] [diff] [review]
Diff from meanwhile 1.0.2 and libpurple 2.9.0

*** Original post on bio 102 as attmnt 778 at 2011-08-18 01:18:00 UTC ***

This is the diff of the changes I made to meanwhile 1.0.2 and the sametime protocol plugin from libpurple 2.9.0 to get them to compile using MSVC. As far as I know, they're just syntax changes from GNU-C to "proper" C.
(Assignee)

Comment 12

4 years ago
Comment on attachment 8352518 [details] [diff] [review]
Diff of meanwhile 1.0.2

*** Original change on bio 102 attmnt 776 at 2011-08-18 01:18:25 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352518 - Attachment is obsolete: true
(Assignee)

Comment 13

4 years ago
Created attachment 8352521 [details] [diff] [review]
Sametime from libpurple 2.9.0 / Meanwhile 1.0.2 (Take 2)

*** Original post on bio 102 as attmnt 779 at 2011-08-18 01:30:00 UTC ***

This adds Sametime to Instantbird (using libpurple 2.9.0 and Meanwhile 1.0.2) and makes the changes to all the upgrade scripts, etc.

This also includes the sametime.properties file and script changes from flo, thanks!  I'm fairly confident this is all the necessary files, but it's possible I missed some (it's a lot of files split over many places, but I checked multiple times).
Attachment #8352521 - Flags: review?(florian)
(Assignee)

Comment 14

4 years ago
Comment on attachment 8352510 [details] [diff] [review]
Sametime from Pidgin 2.9.0 / Meanwhile 1.0.2

*** Original change on bio 102 attmnt 768 at 2011-08-18 01:30:59 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352510 - Attachment is obsolete: true
(Assignee)

Comment 15

4 years ago
Comment on attachment 8352519 [details] [diff] [review]
sametime.properties + a few script changes

*** Original change on bio 102 attmnt 777 at 2011-08-18 01:30:59 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352519 - Attachment is obsolete: true
*** Original post on bio 102 at 2011-08-18 10:19:54 UTC ***

Comment on attachment 8352520 [details] [diff] [review] (bio-attmnt 778)
Diff from meanwhile 1.0.2 and libpurple 2.9.0

I didn't know you had to edit the PurplePluginProtocolInfo structure, but as you did, these warnings are definitely yours, and are scary:

sametime.c
purple/libpurple/protocols/sametime/sametime.c:5277: warning: initialization from incompatible pointer type
purple/libpurple/protocols/sametime/sametime.c:5278: warning: initialization from incompatible pointer type
purple/libpurple/protocols/sametime/sametime.c:5279: warning: initialization from incompatible pointer type
purple/libpurple/protocols/sametime/sametime.c:5284: warning: initialization makes pointer from integer without a cast
purple/libpurple/protocols/sametime/sametime.c:5284: warning: missing initializer
purple/libpurple/protocols/sametime/sametime.c:5284: warning: (near initialization for ‘mw_prpl_info.roomlist_room_serialize')
(Assignee)

Comment 17

4 years ago
*** Original post on bio 102 at 2011-08-18 12:27:31 UTC ***

(In reply to comment #13)
> (From update of attachment 8352520 [details] [diff] [review] (bio-attmnt 778) [details])
> I didn't know you had to edit the PurplePluginProtocolInfo structure, but as
> you did, these warnings are definitely yours, and are scary:
> 
> sametime.c
> purple/libpurple/protocols/sametime/sametime.c:5277: warning: initialization
> from incompatible pointer type
> purple/libpurple/protocols/sametime/sametime.c:5278: warning: initialization
> from incompatible pointer type
> purple/libpurple/protocols/sametime/sametime.c:5279: warning: initialization
> from incompatible pointer type
> purple/libpurple/protocols/sametime/sametime.c:5284: warning: initialization
> makes pointer from integer without a cast
> purple/libpurple/protocols/sametime/sametime.c:5284: warning: missing
> initializer
> purple/libpurple/protocols/sametime/sametime.c:5284: warning: (near
> initialization for ‘mw_prpl_info.roomlist_room_serialize')
These lines don't match the diff, but flo told me locally it's the | mw_prpl_can_receive_file,| line. And "you should check that the structure as the same members as http://lxr.instantbird.org/instantbird/source/purple/libpurple/prpl.h#221 and that they are in the same order. It's very likely that you just missed a NULL somewhere causing an offset for a few function pointers, and causing the missing initializer".

When comparing it there, it's missing a null before the can_receive_file and four nulls before the sizeof line (and a bunch of nulls after the sizeof line). New patch will be up later.
(Assignee)

Comment 18

4 years ago
Created attachment 8352522 [details] [diff] [review]
Diff from meanwhile 1.0.2 and libpurple 2.9.0 (Take 3)

*** Original post on bio 102 as attmnt 780 at 2011-08-19 02:09:00 UTC ***

Updated diff of meanwhile/sametime.
(Assignee)

Comment 19

4 years ago
Comment on attachment 8352520 [details] [diff] [review]
Diff from meanwhile 1.0.2 and libpurple 2.9.0

*** Original change on bio 102 attmnt 778 at 2011-08-19 02:09:18 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352520 - Attachment is obsolete: true
(Assignee)

Comment 20

4 years ago
Created attachment 8352523 [details] [diff] [review]
Sametime from libpurple 2.9.0 / Meanwhile 1.0.2 (Take 3)

*** Original post on bio 102 as attmnt 781 at 2011-08-19 02:10:00 UTC ***

This should fix the issues with the PurplePluginProtocolInfo, I don't have any warnings in my make, but GCC (which I assume you're using on Mac) might give different ones.
Attachment #8352523 - Flags: review?(florian)
(Assignee)

Comment 21

4 years ago
Comment on attachment 8352521 [details] [diff] [review]
Sametime from libpurple 2.9.0 / Meanwhile 1.0.2 (Take 2)

*** Original change on bio 102 attmnt 779 at 2011-08-19 02:10:35 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352521 - Attachment is obsolete: true
Attachment #8352521 - Flags: review?(florian)
Comment on attachment 8352523 [details] [diff] [review]
Sametime from libpurple 2.9.0 / Meanwhile 1.0.2 (Take 3)

*** Original change on bio 102 attmnt 781 at 2011-08-29 23:41:16 UTC ***

Clearing the review request. We discussed on IRC that this is not ready because of the way the server hostname is specified, and you have a WIP of a solution for that new issue.
Attachment #8352523 - Flags: review?(florian)
(Assignee)

Comment 23

4 years ago
Created attachment 8352538 [details] [diff] [review]
Sametime from libpurple 2.9.0 / Meanwhile 1.0.2 (Take 4)

*** Original post on bio 102 as attmnt 796 at 2011-08-30 23:20:00 UTC ***

This adds the username split back, but it also adds a string that is not currently in the properties file, a diff from meanwhile/libpurple will be put up soon.

My changes to sametime.c were checked by flo and EionRobb.
Attachment #8352538 - Flags: review?(florian)
(Assignee)

Comment 24

4 years ago
Comment on attachment 8352523 [details] [diff] [review]
Sametime from libpurple 2.9.0 / Meanwhile 1.0.2 (Take 3)

*** Original change on bio 102 attmnt 781 at 2011-08-30 23:20:31 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352523 - Attachment is obsolete: true
(Assignee)

Comment 25

4 years ago
Created attachment 8352539 [details] [diff] [review]
Diff from meanwhile 1.0.2 and libpurple 2.9.0 (Take 4)

*** Original post on bio 102 as attmnt 797 at 2011-08-30 23:35:00 UTC ***

Final diff of libpurple/meanwhile (I will be filing a bug with Pidgin to upstream the changes to libpurple).
(Assignee)

Comment 26

4 years ago
Comment on attachment 8352522 [details] [diff] [review]
Diff from meanwhile 1.0.2 and libpurple 2.9.0 (Take 3)

*** Original change on bio 102 attmnt 780 at 2011-08-30 23:35:34 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352522 - Attachment is obsolete: true
(Assignee)

Comment 27

4 years ago
*** Original post on bio 102 at 2011-08-31 00:01:04 UTC ***

Flo found a public Sametime server at https://greenhouse.lotus.com/gh_next/lotusgreenhouserequests.nsf/MainDocumentSelf?openForm (sametime.lotus.com). (We've registered, maybe we'll get an account...)
Comment on attachment 8352538 [details] [diff] [review]
Sametime from libpurple 2.9.0 / Meanwhile 1.0.2 (Take 4)

*** Original change on bio 102 attmnt 796 at 2011-08-31 00:26:48 UTC was without comment, so any subsequent comment numbers will be shifted ***
Attachment #8352538 - Attachment is patch: true
Attachment #8352538 - Attachment mime type: application/octet-stream → text/plain
Attachment #8352538 - Flags: review?(florian) → review+
*** Original post on bio 102 at 2011-08-31 00:35:09 UTC ***

https://hg.instantbird.org/instantbird/rev/c398083e6364
Status: ASSIGNED → RESOLVED
Last Resolved: 4 years ago
Resolution: --- → FIXED
Target Milestone: --- → 1.1
(Assignee)

Comment 30

4 years ago
*** Original post on bio 102 at 2011-09-16 10:36:38 UTC ***

Upstreaming this at http://developer.pidgin.im/ticket/14608
Depends on: 954510
You need to log in before you can comment on or make changes to this bug.